﻿using System;
using System.Collections.Generic;

using Xamarin.Forms;

namespace RealmFormsListViewSelectRepro
{
	public partial class MonkeysPage : ContentPage
	{
		MonkeysViewModel viewModel;

		public MonkeysPage()
		{
			InitializeComponent();

			viewModel = new MonkeysViewModel();

			BindingContext = viewModel;
		}

		protected override void OnAppearing()
		{
			base.OnAppearing();

			listView.ItemSelected += ListView_ItemSelected;
		}

		protected override void OnDisappearing()
		{
			listView.ItemSelected -= ListView_ItemSelected;

			base.OnDisappearing();
		}

		async void ListView_ItemSelected(object sender, SelectedItemChangedEventArgs e)
		{
			if (e.SelectedItem == null)
				return;

			var monkeyName = (e.SelectedItem as Monkey)?.Name;

			// IMPORTANT: This will hang / crash
			listView.SelectedItem = null;

			if (!string.IsNullOrEmpty(monkeyName))
				await Navigation.PushModalAsync(new NavigationPage (new MonkeyPage (monkeyName)));
		}
	}
}
